/*!
* Dynamsoft JavaScript Library
* @product Dynamsoft Code Parser JS Edition
* @website http://www.dynamsoft.com
* @copyright Copyright 2024, Dynamsoft Corporation
* @author Dynamsoft
* @version 2.4.32
* @fileoverview Dynamsoft JavaScript Library for Code Parser
* More info on dcp JS: https://www.dynamsoft.com/code-parser/docs/web/programming/javascript/
*/
import{mapPackageRegister as e,loadWasm as t,getNextTaskID as s,mapTaskCallBack as r,worker as n,requestResource as i,CoreModule as a,workerAutoResources as o,compareVersion as c,innerVersions as d,handleEngineResourcePaths as l}from"dynamsoft-core";var u,f;function p(e){delete e.moduleId;const t=JSON.parse(e.jsonString).ResultInfo,s=e.fullCodeString;e.getFieldValue=e=>"fullcodestring"===e.toLowerCase()?s:h(t,e,"map"),e.getFieldRawValue=e=>h(t,e,"raw"),e.getFieldMappingStatus=e=>g(t,e),e.getFieldValidationStatus=e=>y(t,e),delete e.fullCodeString}function h(e,t,s){for(let r of e){if(r.FieldName===t)return"raw"===s&&r.RawValue?r.RawValue:r.Value;if(r.ChildFields&&r.ChildFields.length>0){let e;for(let n of r.ChildFields)e=h(n,t,s);if(void 0!==e)return e}}}function g(e,t){for(let s of e){if(s.FieldName===t)return s.MappingStatus?Number(u[s.MappingStatus]):u.MS_NONE;if(s.ChildFields&&s.ChildFields.length>0){let e;for(let r of s.ChildFields)e=g(r,t);if(void 0!==e)return e}}}function y(e,t){for(let s of e){if(s.FieldName===t&&s.ValidationStatus)return s.ValidationStatus?Number(f[s.ValidationStatus]):f.VS_NONE;if(s.ChildFields&&s.ChildFields.length>0){let e;for(let r of s.ChildFields)e=y(r,t);if(void 0!==e)return e}}}function S(e){if(e.disposed)throw new Error('"CodeParser" instance has been disposed')}!function(e){e[e.MS_NONE=0]="MS_NONE",e[e.MS_SUCCEEDED=1]="MS_SUCCEEDED",e[e.MS_FAILED=2]="MS_FAILED"}(u||(u={})),function(e){e[e.VS_NONE=0]="VS_NONE",e[e.VS_SUCCEEDED=1]="VS_SUCCEEDED",e[e.VS_FAILED=2]="VS_FAILED"}(f||(f={}));const m=e=>e&&"object"==typeof e&&"function"==typeof e.then,w=(async()=>{})().constructor;class _ extends w{get status(){return this._s}get isPending(){return"pending"===this._s}get isFulfilled(){return"fulfilled"===this._s}get isRejected(){return"rejected"===this._s}get task(){return this._task}set task(e){let t;this._task=e,m(e)?t=e:"function"==typeof e&&(t=new w(e)),t&&(async()=>{try{const s=await t;e===this._task&&this.resolve(s)}catch(t){e===this._task&&this.reject(t)}})()}get isEmpty(){return null==this._task}constructor(e){let t,s;super(((e,r)=>{t=e,s=r})),this._s="pending",this.resolve=e=>{this.isPending&&(m(e)?this.task=e:(this._s="fulfilled",t(e)))},this.reject=e=>{this.isPending&&(this._s="rejected",s(e))},this.task=e}}class E{constructor(){this._instanceID=void 0,this.bDestroyed=!1}static async createInstance(){if(!e.license)throw Error("Module `license` is not existed.");await e.license.dynamsoft(),await t("dcp");const i=new E,a=new _;let o=s();return r[o]=async e=>{if(e.success)i._instanceID=e.instanceID,a.resolve(i);else{const t=Error(e.message);e.stack&&(t.stack=e.stack),a.reject(t)}},n.postMessage({type:"dcp_createInstance",id:o}),a}async dispose(){S(this);let e=s();this.bDestroyed=!0,r[e]=e=>{if(!e.success){let t=new Error(e.message);throw t.stack=e.stack+"\n"+t.stack,t}},n.postMessage({type:"dcp_dispose",id:e,instanceID:this._instanceID})}get disposed(){return this.bDestroyed}async initSettings(e){return S(this),e&&["string","object"].includes(typeof e)?("string"==typeof e?e.trimStart().startsWith("{")||(e=await i(e,"text")):"object"==typeof e&&(e=JSON.stringify(e)),await new Promise(((t,i)=>{let a=s();r[a]=async e=>{if(e.success){const s=JSON.parse(e.response);if(0!==s.errorCode){let e=new Error(s.errorString?s.errorString:"Init Settings Failed.");return e.errorCode=s.errorCode,i(e)}return t(s)}{let t=new Error(e.message);return t.stack=e.stack+"\n"+t.stack,i(t)}},n.postMessage({type:"dcp_initSettings",id:a,instanceID:this._instanceID,body:{settings:e}})}))):console.error("Invalid settings.")}async resetSettings(){return S(this),await new Promise(((e,t)=>{let i=s();r[i]=async s=>{if(s.success)return e();{let e=new Error(s.message);return e.stack=s.stack+"\n"+e.stack,t(e)}},n.postMessage({type:"dcp_resetSettings",id:i,instanceID:this._instanceID})}))}async parse(e,t=""){if(S(this),!(e&&(e instanceof Array||e instanceof Uint8Array||"string"==typeof e)))throw new Error("`parse` must pass in an Array or Uint8Array or string");return await new Promise(((i,a)=>{let o=s();e instanceof Array&&(e=Uint8Array.from(e)),"string"==typeof e&&(e=Uint8Array.from(function(e){let t=[];for(let s=0;s<e.length;++s)t.push(e.charCodeAt(s));return t}(e))),r[o]=async e=>{if(e.success){let t=JSON.parse(e.parseResponse);return t.errorCode?a(new Error(t.errorString)):(p(t),i(t))}{let t=new Error(e.message);return t.stack=e.stack+"\n"+t.stack,a(t)}},n.postMessage({type:"dcp_parse",id:o,instanceID:this._instanceID,body:{source:e,taskSettingName:t}})}))}}const k="undefined"==typeof self,C="function"==typeof importScripts,D=(()=>{if(!C){if(!k&&document.currentScript){let e=document.currentScript.src,t=e.indexOf("?");if(-1!=t)e=e.substring(0,t);else{let t=e.indexOf("#");-1!=t&&(e=e.substring(0,t))}return e.substring(0,e.lastIndexOf("/")+1)}return"./"}})(),I=e=>{if(null==e&&(e="./"),k||C);else{let t=document.createElement("a");t.href=e,e=t.href}return e.endsWith("/")||(e+="/"),e};a.engineResourcePaths.dcp={version:"2.4.32",path:D,isInternal:!0},o.dcp={js:!0,wasm:!0,deps:["license"]},e.dcp={handleParsedResultItem:p};const N="1.4.21";"string"!=typeof a.engineResourcePaths.std&&c(a.engineResourcePaths.std.version,N)<0&&(a.engineResourcePaths.std={version:N,path:I(D+`../../dynamsoft-capture-vision-std@${N}/dist/`),isInternal:!0});class F{static getVersion(){const e=d.dcp&&d.dcp.wasm,t=d.dcp&&d.dcp.worker;return`2.4.32(Worker: ${t||"Not Loaded"}, Wasm: ${e||"Not Loaded"})`}static async loadSpec(e,i){return await t("dcp"),await new Promise(((t,o)=>{let c=s();r[c]=async e=>{if(e.success)return t();{let t=new Error(e.message);return t.stack=e.stack+"\n"+t.stack,o(t)}},i&&!i.endsWith("/")&&(i+="/");const d=e instanceof Array?e:[e],u=l(a.engineResourcePaths);n.postMessage({type:"dcp_appendResourceBuffer",id:c,body:{specificationPath:i||u.dcp+"specification/",specificationNames:d}})}))}}export{E as CodeParser,F as CodeParserModule,u as EnumMappingStatus,f as EnumValidationStatus};
